
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

/* =============================================
	xvis user interface builder for Athena widgets using
	xv class library.

	Resource Segment

	V1.0BETA  - last edited 25/06/96
    ============================================= */

// ---------------------------------------------
// Include file declarations

#include "xvis.h"

// ---------------------------------------------
// Global Resources for each object type

// objectType XVTimer

char *timer_resource[] = {	"Objectname", "Interval"};
char *timer_type[] = {	xvNobjectName, xvNtimerInterval };
resourceType timer_data[] = { XVName, XVTime };
int timer_num=2;
callType timer_call[] = { XVTimeout };
char *timer_callname[] = { "timeout" };
int timer_callnum=1;

// objectType XVList

char *list_resource[] = {	"List Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Enabled", "Visible", "Cursor", "Font", "Height", "Width", "X", "Y" };
char *list_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, XtNborderWidth,
					xvNenabled, xvNvisible, XtNcursorName, XtNfont, 
					XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance};
resourceType list_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, 
						XVLocBoolean, XVLocBoolean, XVCursor, XVFont, XVDimension, XVDimension, XVPosition, 
						XVPosition};
int list_num=13;
callType list_call[] = { XVCallback };
char *list_callname[] = { "select" };
int list_callnum=1;

// objectType XVButton

char *button_resource[] = {	"Button Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Justify", "Enabled", "Visible", "Caption", "Shadow Width", "Shape",
						"Top Shadow Colour", "Bottom Shadow Colour",
						"Cursor", "Font", "Bitmap File", "Left Bitmap",
						"Height", "Width", "X", "Y" };
char *button_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, XtNborderWidth,
					XtNjustify, xvNenabled, xvNvisible, XtNlabel, XtNshadowWidth, 
					XtNshapeStyle, XtNtopShadowPixel, XtNbottomShadowPixel,
					XtNcursorName,
					XtNfont, xvNbitmapFile, xvNleftBitmap,
					XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance};
resourceType button_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, 
							XVJustify, XVLocBoolean, XVLocBoolean, XVString, XVDimension, 
							XVShapeStyle, XVPixel, XVPixel,
							XVCursor, XVFont, XVBitmapFile, XVBitmapFile, 
							XVDimension, XVDimension, XVPosition, XVPosition};

int button_num=21;
callType button_call[] = { XVCallback };
char *button_callname[] = { "click" };
int button_callnum=1;

// objectType XVRepeater

char *repeater_resource[] = {	"Repeater Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Justify", "Enabled", "Visible", "Caption", "Shadow Width", "Shape",
						"Top Shadow Colour", "Bottom Shadow Colour",
						"Cursor", "Font", "Bitmap File", "Left Bitmap",
						"Height", "Width", "X", "Y"  };
char *repeater_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, 
					XtNborderWidth, XtNjustify, xvNenabled, xvNvisible, XtNlabel,
					XtNshadowWidth, XtNshapeStyle,
					XtNtopShadowPixel, XtNbottomShadowPixel,
					XtNcursorName, XtNfont, xvNbitmapFile, xvNleftBitmap,
					XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance };
resourceType repeater_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, 
							XVJustify, XVLocBoolean, XVLocBoolean, XVString, XVDimension, 
							XVShapeStyle, XVPixel, XVPixel,
							XVCursor, XVFont, XVBitmapFile, XVBitmapFile,
							XVDimension, XVDimension, XVPosition, XVPosition };
int repeater_num=21;
callType repeater_call[] = { XVCallback, XVCallback, XVCallback };
char *repeater_callname[] = { "click", "start", "stop" };
int repeater_callnum=3;

// objectType XVBitmap

char *bitmap_resource[] = {	"Bitmap Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Shadow Width", "Top Shadow Colour", "Bottom Shadow Colour",
						"Cursor", "Bitmap File",
						"Enabled", "Visible", "Height", "Width", "X", "Y" };
char *bitmap_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, 
					XtNborderWidth, XtNshadowWidth, XtNtopShadowPixel, XtNbottomShadowPixel,
					XtNcursorName, xvNbitmapFile, xvNenabled, xvNvisible, 
					XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance };
resourceType bitmap_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, 
							 XVDimension, XVPixel, XVPixel,
							XVCursor, XVBitmapFile, XVLocBoolean, XVLocBoolean, 
							XVDimension, XVDimension, XVPosition, XVPosition };
int bitmap_num=16;
callType bitmap_call[] = { XVNoCall };
char *bitmap_callname[] = { NULL };
int bitmap_callnum=0;

// objectType XVLabel

char *label_resource[] = {	"Label Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Justify", "Enabled", "Visible", "Caption", "Shadow Width", 
						"Top Shadow Colour", "Bottom Shadow Colour",
						"Cursor", "Font", "Bitmap File", "Left Bitmap",
						"Height", "Width", "X", "Y"  };
char *label_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, 
					XtNborderWidth, XtNjustify, xvNenabled, xvNvisible, XtNlabel,
					XtNshadowWidth, XtNtopShadowPixel, XtNbottomShadowPixel,
					XtNcursorName, XtNfont, xvNbitmapFile, xvNleftBitmap,
					XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance };
resourceType label_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, XVJustify,
						XVLocBoolean, XVLocBoolean, XVString, XVDimension, XVPixel, XVPixel,
						XVCursor, XVFont, XVBitmapFile, XVBitmapFile,
						XVDimension, XVDimension, XVPosition, XVPosition };
int label_num=20;
callType label_call[] = { XVNoCall };
char *label_callname[] = { NULL };
int label_callnum=0;

// objectType XVDropDown

char *dropdown_resource[] = {"Dropdown Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Enabled", "Visible", "Cursor", "Font", "Height", "Width", "X", "Y" };
char *dropdown_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, 
						XtNborderWidth, xvNenabled, xvNvisible, XtNcursorName, XtNfont, XtNheight, XtNwidth, 
						XtNhorizDistance, XtNvertDistance };
resourceType dropdown_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, 
							XVLocBoolean, XVLocBoolean, XVCursor, XVFont,
							XVDimension, XVDimension, XVPosition, XVPosition };
int dropdown_num=13;
callType dropdown_call[] = { XVCallback, XVCallback };
char *dropdown_callname[] = { "click", "select" };
int dropdown_callnum=2;

// objectType XVEditField

char *editfield_resource[] = {	"Editfield Name", "Background", "Foreground", "BorderColour", 
						"BorderWidth", "Edit Mode", 
						"AutoWrap", "Wrap Mode", 
						"Horizontal Scroll", "Vertical Scroll", 
						"Resize Mode", "Display Non-printables", "Echo Characters",
						"Enabled", "Visible", "Cursor", "Font","Height", "Width", "X", "Y"  };
char *editfield_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, 
					XtNborderWidth, xvNeditmode,
					xvNautowrap, xvNwrapmode, 
					xvNHscrollmode, xvNVscrollmode,
					xvNresizemode,xvNctrl, xvNecho, 
					xvNenabled, xvNvisible, XtNcursorName, XtNfont,
					XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance };
resourceType editfield_data[] = {	XVName, XVPixel, XVPixel, XVPixel, 
							XVDimension, XVEditmode, 
							XVLocBoolean, XVWrap, 
							XVhScroll, XVvScroll, XVResize, 
							XVLocBoolean, XVLocBoolean, 
							XVLocBoolean, XVLocBoolean, XVCursor, XVFont,
							XVDimension, XVDimension, XVPosition, XVPosition };
int editfield_num=21;
callType editfield_call[] = { XVCallback };
char *editfield_callname[] = { "change" };
int editfield_callnum=1;

// objectType XVBox

char *box_resource[] = {	"Box Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Enabled", "Visible", "Height", "Width", "X", "Y" };
char *box_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, 
					XtNborderWidth, xvNenabled, xvNvisible, 
					XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance };
resourceType box_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension,
						XVLocBoolean, XVLocBoolean,  
						XVDimension, XVDimension, XVPosition, XVPosition };
int box_num=11;
callType box_call[] = { XVNoCall };
char *box_callname[] = { NULL };
int box_callnum=0;

// objectType XVToggle

char *toggle_resource[] = {	"Toggle Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Justify", "Enabled", "Visible", "Caption", "Shadow Width", "Shape",
						"Top Shadow Colour", "Bottom Shadow Colour",
						"Cursor", "Font", "Group With...",
						"Bitmap File", "Left Bitmap", "Height", "Width", "X", "Y" };
char *toggle_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, 
					XtNborderWidth, XtNjustify, xvNenabled, xvNvisible, XtNlabel,
					XtNshadowWidth, XtNshapeStyle, 
					XtNtopShadowPixel, XtNbottomShadowPixel,
					XtNcursorName, XtNfont, xvNobjectRef, xvNbitmapFile,
					xvNleftBitmap,
					XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance };
resourceType toggle_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, 
							XVJustify, XVLocBoolean, XVLocBoolean, XVString, 
							XVDimension, XVShapeStyle,
							XVPixel, XVPixel, 
							XVCursor, XVFont, XVObject, XVBitmapFile, XVBitmapFile,
							XVDimension, XVDimension, XVPosition, XVPosition };
int toggle_num=22;
callType toggle_call[] = { XVCallback };
char *toggle_callname[] = { "click" };
int toggle_callnum=1;

// objectType XVForm

char *form_resource[] = {	"Form Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Enabled", "Visible", "Height", "Width", "X", "Y" };
char *form_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, XtNborderWidth,
					xvNenabled, xvNvisible, XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance };
resourceType form_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, 
						XVLocBoolean, XVLocBoolean, 
						XVDimension, XVDimension, XVPosition, XVPosition };
int form_num=11;
callType form_call[] = { XVNoCall };
char *form_callname[] = { NULL };
int form_callnum=0;

// objectType XVVScroll &XVHScroll

char *scroll_resource[] = {	"Scroll Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Shadow Width", "Top Shadow Colour", "Bottom Shadow Colour", 
						"Enabled", "Visible", "Height", "Width", "X", "Y"  };
char *scroll_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, XtNborderWidth,
					XtNshadowWidth, XtNtopShadowPixel, XtNbottomShadowPixel,
					xvNenabled, xvNvisible, XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance };
resourceType scroll_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension,  
						XVDimension, XVPixel, XVPixel, 
						XVLocBoolean, XVLocBoolean, 
						XVDimension, XVDimension, XVPosition, XVPosition };
int scroll_num=14;
callType scroll_call[] = { XVCallback, XVCallback, XVCallback };
char *scroll_callname[] = { "scroll", "thumb", "jump" };
int scroll_callnum=3;

// objectType XVPanner

char *panner_resource[] = {	"Panner Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Enabled", "Visible", "Cursor", "Height", "Width", "X", "Y"}; 
char *panner_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, XtNborderWidth,
					xvNenabled, xvNvisible, XtNcursorName, XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance};
resourceType panner_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, 
							XVLocBoolean, XVLocBoolean, XVCursor,
							XVDimension, XVDimension, XVPosition, XVPosition};
int panner_num=12;
callType panner_call[] = { XVCallback };
char *panner_callname[] = { "move" };
int panner_callnum=1;

// object XVFileList

char *filelist_resource[] = {	"FileList Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Enabled", "Visible", "Cursor", "Font", "Default Path", "Height", "Width", "X", "Y" }; 
char *filelist_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, XtNborderWidth,	
					xvNenabled, xvNvisible, XtNcursorName, XtNfont, xvNpath,
					XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance };
resourceType filelist_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, 
							XVLocBoolean, XVLocBoolean, XVCursor, XVFont, XVPath,
							XVDimension, XVDimension, XVPosition, XVPosition};
int filelist_num=14;
callType filelist_call[] = { XVCallback };
char *filelist_callname[] = { "select" };
int filelist_callnum=1;

// object XVDirList

char *dirlist_resource[] = {	"DirList Name", "Background", "Foreground", "BorderColour", "BorderWidth", 
						"Enabled", "Visible", "Cursor", "Font", "Default Path", "Height", "Width", "X", "Y" }; 
char *dirlist_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor, XtNborderWidth,	
					xvNenabled, xvNvisible, XtNcursorName, XtNfont, xvNpath,
					XtNheight, XtNwidth, XtNhorizDistance, XtNvertDistance};
resourceType dirlist_data[] = {	XVName, XVPixel, XVPixel, XVPixel, XVDimension, 
							XVLocBoolean, XVLocBoolean, XVCursor, XVFont, XVPath,
							XVDimension, XVDimension, XVPosition, XVPosition};
int dirlist_num=14;
callType dirlist_call[] = { XVCallback };
char *dirlist_callname[] = { "select" };
int dirlist_callnum=1;

// objectType XVWindow

char *window_resource[] = {	"Window Name", "Background", "Foreground", "BorderColour", 
						"Caption", "Icon", "Iconic", "Startup", 
						"Height", "Width", 
						"Fixed Size", "X", "Y"};
char *window_type[] = {	xvNobjectName, XtNbackground, XtNforeground, XtNborderColor,
					XtNtitle, xvNicon, xvNiconic, xvNopenAtStart, XtNheight, XtNwidth, 
					xvNfixed, XtNx, XtNy};
resourceType window_data[] = {	XVName, XVPixel, XVPixel, XVPixel, 
							XVWinName, XVBitmapFile, XVLocBoolean, 
							XVLocBoolean, XVWinSize, 
							XVWinSize, XVLocBoolean, XVWinPositionX, XVWinPositionY};
int window_num=13;
callType window_call[] = { XVNoCall };
char *window_callname[] = { NULL };
int window_callnum=0;

// objectType XVNone / Pointer

char *none_resource[] = { "No Object Selected" };
char *none_type[] = { xvNnone };
resourceType none_data[] = { XVVoid };
int none_num=1;
callType none_call[] = { XVNoCall };
char *none_callname[] = { NULL };
int none_callnum=0;

// References to the object resources in type order...

char* *object_resources[] = {	timer_resource, list_resource, button_resource, repeater_resource,
						bitmap_resource, label_resource, dropdown_resource,
						editfield_resource, box_resource, toggle_resource, form_resource,
						scroll_resource, scroll_resource, panner_resource, 
						filelist_resource, dirlist_resource, window_resource, 
						none_resource, none_resource };

char* *object_resource_types[] = {	timer_type, list_type, button_type, repeater_type,
							bitmap_type, label_type, dropdown_type,
							editfield_type, box_type, toggle_type, form_type,
							scroll_type, scroll_type, panner_type, 
							filelist_type, dirlist_type, window_type, 
							none_type, none_type };

resourceType* object_data_types[] = {	timer_data, list_data, button_data, repeater_data,
								bitmap_data, label_data, dropdown_data,
								editfield_data, box_data, toggle_data, form_data,
								scroll_data, scroll_data, panner_data, 
								filelist_data, dirlist_data, window_data,
								none_data, none_data };

int object_resource_number[] = {	timer_num, list_num, button_num, repeater_num,
							bitmap_num, label_num, dropdown_num,
							editfield_num, box_num, toggle_num, form_num,
							scroll_num, scroll_num, panner_num, 
							filelist_num, dirlist_num, window_num, 
							none_num, none_num };


callType* object_call_types[] = {	timer_call, list_call, button_call, repeater_call,
							bitmap_call, label_call, dropdown_call,
							editfield_call, box_call, toggle_call, form_call,
							scroll_call, scroll_call, panner_call, 
							filelist_call, dirlist_call, window_call, 
							none_call, none_call };

char* *object_call_names[] = {	timer_callname, list_callname, button_callname, repeater_callname,
							bitmap_callname, label_callname, dropdown_callname,
							editfield_callname, box_callname, toggle_callname, form_callname,
							scroll_callname, scroll_callname, panner_callname, 
							filelist_callname, dirlist_callname, window_callname, 
							none_callname, none_callname };

int object_call_number[] = {		timer_callnum, list_callnum, button_callnum, repeater_callnum,
							bitmap_callnum, label_callnum, dropdown_callnum,
							editfield_callnum, box_callnum, toggle_callnum, form_callnum,
							scroll_callnum, scroll_callnum, panner_callnum, 
							filelist_callnum, dirlist_callnum, window_callnum, 
							none_callnum, none_callnum };
